Index: trunk/calendar/inc/class.uicalendar.inc.php
===================================================================
--- trunk/calendar/inc/class.uicalendar.inc.php	(revision 4844)
+++ trunk/calendar/inc/class.uicalendar.inc.php	(revision 5132)
@@ -57,6 +57,4 @@
 
 		var $public_functions = array(
-			'screen_delegate_event' => True,
-			'delegate_event' => True,
 			'mini_calendar' => True,
 			'index' => True,
@@ -67,4 +65,6 @@
 			'year' => True,
 			'view' => True,
+			//'suggest' => True,
+			'send_suggest_owner' => True,
 			'edit' => True,
 			'export'	=> True,
@@ -92,4 +92,9 @@
 		function uicalendar()
 		{
+		    $GLOBALS['phpgw_info']['flags']['noappheader'] = True;
+			$GLOBALS['phpgw_info']['flags']['noappfooter'] = True;
+                        $GLOBALS['phpgw_info']['flags']['currentapp'] = 'calendar';
+                        include_once( $_SESSION['rootPath'].'/header.inc.php' );
+
 			$GLOBALS['phpgw']->nextmatchs = CreateObject('phpgwapi.nextmatchs');
 			$GLOBALS['phpgw']->browser    = CreateObject('phpgwapi.browser');
@@ -163,92 +168,4 @@
 			}
 			$this->html = &$GLOBALS['phpgw']->html;
-		}
-
-		function screen_delegate_event($params=NULL) {
-			$module_name = 'expressoMail'.(str_replace("1.","1_",$GLOBALS['phpgw_info']['server']['cal_expressoMail']));
-
-			$sb = CreateObject('phpgwapi.sbox2');
-			$jscal = CreateObject('phpgwapi.jscalendar');	// before phpgw_header() !!!
-			unset($GLOBALS['phpgw_info']['flags']['noheader']);
-			unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
-			$GLOBALS['phpgw_info']['flags']['noappheader'] = True;
-			$GLOBALS['phpgw_info']['flags']['noappfooter'] = True;
-			$GLOBALS['phpgw_info']['flags']['app_header'] = $event['id'] ? lang('Calendar - Edit') : lang('Calendar - Delegate Event'); 
-			$GLOBALS['phpgw']->common->phpgw_header();
-
-			$ldap_manager = CreateObject('contactcenter.bo_ldap_manager');
-			$_SESSION['phpgw_info']['expressomail']['user'] = $GLOBALS['phpgw_info']['user'];
-			$_SESSION['phpgw_info']['expressomail']['user']['owner'] = $event['owner'];
-			$_SESSION['phpgw_info']['expressomail']['server'] = $GLOBALS['phpgw_info']['server'];
-			$_SESSION['phpgw_info']['expressomail']['ldap_server'] = $ldap_manager ? $ldap_manager->srcs[1] : null;
-			$context = $GLOBALS['phpgw_info']['server']['ldap_context'];
-			$user_context = array();
-			foreach(explode(",",$GLOBALS['phpgw_info']['user']['account_dn']) as $i => $dn_part){
-				if($i)
-					$user_context[] = $dn_part;
-			}
-			// Prepara o contexto do usuario com sua OU raiz, pois ele pode pertencer a uma OU de nivel N.
-			$user_ou = explode(",",str_replace($context,"",implode(",",$user_context)));
-			$user_context = trim(strtolower($user_ou[count($user_ou) - 2].",".$context));
-			// Fim
-			// Verifica o tipo da visualização da árvore LDAP, configurado no admin da Agenda
-			$recursive = $GLOBALS['phpgw_info']['server']['cal_type_tree_participants'] == '1' ? true : false;
-			$combo_org = $this->get_organizations(trim(strtolower($context)),$user_context, $recursive);
-
-			$var = array(
-				"module_name"		=> $module_name,
-				"lang_loading"		=> lang("Loading"),
-				"lang_searching"	=> lang("Searching"),
-				"lang_users"		=> lang("Users"),
-				"lang_groups"		=> lang("Groups"),
-				"recursive"		=> ($recursive)?"":"search",
-				"options"		=> $combo_org,
-				"id_event"		=> $_REQUEST["id_event"],
-				"eventArray"		=> $_REQUEST["eventArray"],
-				"delegator"		=> $_REQUEST["delegator"],
-				"lang_avaliable_users"	=> lang("Available Users and Groups"),
-				"lang_search_for"	=> lang("Search for"),
-				"lang_ou"		=> lang("Organization"),
-				"min_num_characters"	=> $GLOBALS['phpgw_info']['server']['min_num_characters'],
-				"date"			=> $_REQUEST["date"],
-				"eventDelegation"	=> 1,
-				"Delegate"		=> lang("Delegate"),
-				'url_template'		=> 'calendar/templates/'.$_SESSION['phpgw_info']['calendar']['user']['preferences']['common']['template_set']
-			);
-
-			if(isset($_REQUEST["error"]))
-			{
-				if($_REQUEST["error"] == 999){
-					$var['error_msg'] = lang("Problems delegating. Make sure you have selected a user to delegate the appointment.");
-				}else {
-					$var['error_msg'] = lang("Problems delegating. Make sure you haven't delegated to a person that was also invited to the meeting");
-				}
-			}
-
-			$template = CreateObject('phpgwapi.Template',$this->template_dir);
-			$template->set_file(
-					array(
-						"screen"=>"delegate.tpl"
-					)
-				);
-			$template->set_var($var);
-			print $template->fp('out','screen');
-		}
-
-
-		function delegate_event($params=NULL) {
-			//$ldap = CreateObject('expressoMail1_2.ldap_functions');
-			//$delegated = $ldap->uid2uidnumber($_REQUEST['delegated']);
-
-			try {
-				$this->bo->delegar($_REQUEST['delegator'],$_REQUEST['delegated']/*$delegated*/,$_REQUEST['event']);
-				header("Location: index.php?menuaction=calendar.uicalendar.day&date=".$_REQUEST['date']);
-			}catch(Exception $e) {
-				if($e->getMessage() == '999') {
-					header("Location: index.php?menuaction=calendar.uicalendar.screen_delegate_event&id_event=". $_REQUEST["event"]."&delegator=".$_REQUEST["delegator"]."&date=".$_REQUEST["date"]."&error=999");
-				}else {
-					header("Location: index.php?menuaction=calendar.uicalendar.screen_delegate_event&id_event=". $_REQUEST["event"]."&delegator=".$_REQUEST["delegator"]."&date=".$_REQUEST["date"]."&error=1");
-				}
-			}
 		}
 
@@ -392,27 +309,5 @@
 						{
 //NDEE: class def what for?
-						    $dayToday = (int)(substr($today,6,2));
-						    $seleDay = (int)(substr($_GET['date'],6,2));
-						    if($day == $dayToday)
-						    {
-							if($dayToday == $seleDay)
-							{
-							    $day_params['class'] = 'minicaltodaysel';
-							}
-							else
-							{
-							    $day_params['class'] = 'minicaltoday';
-							}
-						    }
-
-						    if( isset($params['control']) && $params['control'] )
-						    {
-							if($day == $seleDay && $dayToday != $seleDay)
-							{
-							    $day_params['class'] = 'minicalnottoday';
-							}
-						    }
-
-                                                        $str = '<a href="'.$this->page($params['link'],'&date='.$date).'" class="'.$day_params['class'].'" ' . ($day_params['class']=='bminicalhol' || $day_params['class']=='minicalhol'?' title="' . $day_params['holidays'][0] . '" ' :'') . ' >'.$day.'</a>';
+							$str = '<a href="'.$this->page($params['link'],'&date='.$date).'" class="'.$day_params['class'].'">'.$day.'</a>';
 						}
 						else
@@ -473,19 +368,19 @@
 			$_SESSION['calendar']['categories'] = $this->cat->formated_list('select','all',$this->bo->cat_id,'True');
 			if((!isset($GLOBALS['phpgw_info']['server']['deny_user_grants_access']) || !$GLOBALS['phpgw_info']['server']['deny_user_grants_access']) && count($this->bo->grants) > 0)
+			{	
 				$_SESSION['calendar']['cals'] = $this->bo->list_cals();
+			}
 
 			if($this->bo->printer_friendly || $_GET['plain'] == 'True')
 			{	
-				$app_css_path = $_SESSION['phpgw_info']['calendar']['user']['preferences']['common']['template_set'];
-				$app_print_css_path = $app_css_path;
-				if (!file_exists($GLOBALS['phpgw_info']['server']['webserver_url'].'/calendar/templates/'.$app_css_path.'/app.css'))
-					$app_css_path = 'default';
-				if (!file_exists($GLOBALS['phpgw_info']['server']['webserver_url'].'/calendar/templates/'.$app_print_css_path.'/app_print.css'))
-					$app_print_css_path = 'default';
-
 				$new_body = '<html>'."\n"
 					.'<head>'."\n"
-					.'<LINK href="'.$GLOBALS['phpgw_info']['server']['webserver_url'].'/calendar/templates/'.$app_css_path.'/app.css" type=text/css rel=StyleSheet>'."\n"
-					.'<LINK href="'.$GLOBALS['phpgw_info']['server']['webserver_url'].'/calendar/templates/'.$app_print_css_path.'/app_print.css" type=text/css rel=StyleSheet media="print">'."\n"
+					.'<SCRIPT type="text/javascript">
+						window.onbeforeunload = function() {
+							return \'Gostaria realmente de fechar essa janela ?\';
+						}					
+					</SCRIPT>'
+					.'<LINK href="'.$GLOBALS['phpgw_info']['server']['webserver_url'].'/calendar/templates/'.$_SESSION['phpgw_info']['calendar']['user']['preferences']['common']['template_set'].'/app.css" type=text/css rel=StyleSheet>'."\n"
+					.'<LINK href="'.$GLOBALS['phpgw_info']['server']['webserver_url'].'/calendar/templates/'.$_SESSION['phpgw_info']['calendar']['user']['preferences']['common']['template_set'].'/app_print.css" type=text/css rel=StyleSheet media="print">'."\n"
 					.'</head>
 					<table id="calendar_print_main" class="calendar_print_main">						
@@ -493,6 +388,9 @@
 							<td id="calendar_print_content" class="calendar_print_content">'.$body.'</td>
 						</tr>
+						
 						<tr>
 						  <td>
+							<br/>
+							<br/>
 							<div>
 								<input class=button type="button" onClick="javascript:this.style.visibility=\'hidden\';window.print();window.close();" value="Imprimir esta p&aacute;gina">
@@ -516,33 +414,17 @@
 				
 				$GLOBALS['phpgw']->common->phpgw_header();
-				$new_body = $this->bo->debug_string.$body;				
 				
-			}
+				$new_body = $this->bo->debug_string.$body;								
+		}
+
+
+
+			
 			return $new_body;
-		}
+                        }
 
 		function month()
-		{
-                        if($_GET['month']||$_POST['month']){
-                            $params['month'] = $_GET['month']?(int)$_GET['month']:(int)$_POST['month'];
-                            $params['year'] = $_GET['year']?(int)$_GET['year']:(int)$_POST['year'];
-                            $params['day'] = 1;
-
-                        }else{
-                            $params['day'] = $_POST['date']?(int)substr($_POST['date'] , 6, 2):(int)substr($_GET['date'] , 6, 2);
-                            $params['month'] = $_POST['date']?(int)substr($_POST['date'] , 4, 2):(int)substr($_GET['date'] , 4, 2);
-                            $params['year'] = $_POST['date']?(int)substr($_POST['date'] , 0, 4):(int)substr($_GET['date'] , 0, 4);
-
-                        }
-
-			if($_GET['friendly']==1)
 			{
 			    echo $this->printer_friendly($this->get_month(),lang('Monthview'));
-			}
-			else
-			{
-			    echo $this->printer_friendly($this->print_month_new($params),lang('Monthview'));
-			}
-
 			$GLOBALS['phpgw']->common->phpgw_footer();
 		}
@@ -550,4 +432,6 @@
 		function get_month()
 		{
+			$this->bo->read_holidays();
+			
 			$m = mktime(0,0,0,$this->bo->month,1,$this->bo->year);
 
@@ -594,19 +478,45 @@
 				$minical_next = '';
 			}
-                        $this->bo->read_holidays($params['year']);
+
 			if($_POST['year']) {			
 	
 			}
 
+			$hoje = date('Ymd',$GLOBALS['phpgw']->datetime->gmtnow);
+			$mes_hoje = (int)substr($hoje,4,2);
+			$sday = 1;
+			if($_POST['day']) {
+				$day_ini = (int)$_POST['day'];
+			} 
+			elseif($_GET['sday']){
+				if($_GET['month'] == $mes_hoje)
+			{
+					$day_ini = $this->bo->day;
+				} 
+
+				else
+				{
+					$day_ini = (int)$_GET['sday'];
+				}
+			} 
+			elseif( ($_POST['dia_ini']) && ($_POST['dia_ini'] == $this->bo->day) )
+			{
+				$day_ini = (int)substr($hoje,6,2);
+			}
+			else
+			{
+				$day_ini = $this->bo->day;
+			}
+			if($_POST['qtd_dias'])
+			{
+				$num_dias = (int)$_POST['qtd_dias'];
+			} 
+			else
+			{
+				$num_dias = 0;
+			}
+
 			if (!$this->bo->printer_friendly)
 			{
-			    $account_name = $_POST['user'] ? $_POST['user'] : ($_GET['account_name'] ? $_GET['account_name'] : '');
-
-			    $accounts = CreateObject('phpgwapi.accounts');
-			    $accountId = $accounts->name2id($account_name);
-
-			    $prefs = CreateObject('phpgwapi.preferences', $accountId);
-			    $account_prefs = $prefs->read();
-
 			    $printer = '';
 			    $prev_month_link = '<a href="'.$this->page('month','&year='.$prevyear.'&month='.$prev.'&sday='.$sday).'">&lt;&lt;</a>';
@@ -614,24 +524,9 @@
 			    $param = '&year='.$this->bo->year.'&month='.$this->bo->month.'&friendly=1'.'&day_ini='.$day_ini.'&num_dias='.$num_dias;
 			    //$param = '&year='.$this->bo->year.'&month='.$this->bo->month.'&friendly=1';
-			    /*if($account_prefs['calendar']['type_month_print'] == '0')
-			    {
 			    $print = "<a href='javascript:void(0)' onClick=\"javascript:window.open('".$this->page('month'.$param).
 					    "','','width=600,height=600,toolbar=no,scrollbars=yes,resizable=no');\" onMouseOver=\"window.status = '".
 					    lang('Generate printer-friendly version')."'\">[".lang('Printer Friendly').']</a>';
-			    }
-			    else
-			    {
-			    $print =  '<a href="javascript:void(0)" onclick="scheduler.toPDF('."'calendar/js/dhtmlx/server/generate.php'".')">['.lang('Printer Friendly').']</a>';
-			    }*/
-
 			    //linha abaixo foi adicionada para exibir a pagina do mes em tela
-			    //$month,$year,$showyear,$owner=0;
-			    $params = Array(
-				'month'	=> $this->bo->month,
-				'year'	=> $this->bo->year,
-				'showyear'	=> True,
-				'owner'	=> $this->bo->owner
-			    );
-			    $large_month = $this->display_month($params);
+				$large_month = $this->display_month($this->bo->month,$this->bo->year,True,$this->bo->owner);				
 			}
 			else
@@ -643,24 +538,8 @@
 			    $GLOBALS['phpgw_info']['flags']['nofooter'] = True;
 			    //linha abaixo foi adicionada para exibir a pagina do mes para impressao
-
-			    //if($_GET['classic_print']==1)
-			    //	$large_month = $this->display_month($this->bo->month,$this->bo->year,True,$this->bo->owner);
-			    //else
 			    $large_month = $this->display_month_print($this->bo->month,$this->bo->year,True,$this->bo->owner);
 			}
 
 			$this->bo->read_holidays();
-
-			$aux_month_identifier = lang(strftime("%B",$m)).' '.$this->bo->year;
-			if(isset($_GET['friendly']) && $_GET['friendly'] ==1)
-			{
-			    if( isset($_GET['num_dias']) && ($_GET['num_dias'] == 1) )
-			    {
-				$year = $_GET['year'];
-				$month = $_GET['month'];
-				$day = $_GET['day_ini'];
-				$aux_month_identifier = $this->month_day_of_week($year,$month,$day).', '.$day.' de '.lang(strftime("%B",$m)).' de '.$this->bo->year;
-			    }
-			}
 
 			$var = Array(
@@ -669,8 +548,9 @@
 				'small_calendar_prev'	    => $minical_prev,
 				'prev_month_link'	    => $prev_month_link,
-				'month_identifier'	    => $aux_month_identifier,
+				'month_identifier'		=>	lang(strftime("%B",$m)).' '.$this->bo->year,
 				'username'		    => $GLOBALS['phpgw']->common->grab_owner_name($this->bo->owner),
 				'next_month_link'	    => $next_month_link,
 				'small_calendar_next'	    => $minical_next,
+				//'large_month'				=>	$this->display_month($this->bo->month,$this->bo->year,True,$this->bo->owner),
 				'large_month'		    => $large_month,
 				'print'			    => $print
@@ -700,19 +580,5 @@
 		function week()
 		{
-
-                        if($_GET['month']||$_POST['month']){
-                            $params['month'] = $_GET['month']?(int)$_GET['month']:(int)$_POST['month'];
-                            $params['year'] = $_GET['year']?(int)$_GET['year']:(int)$_POST['year'];
-                            $params['day'] = $_GET['day']?(int)$_GET['day']:(int)$_POST['day'];
-
-                        }else{
-                            $params['day'] = $_POST['date']?(int)substr($_POST['date'] , 6, 2):(int)substr($_GET['date'] , 6, 2);
-                            $params['month'] = $_POST['date']?(int)substr($_POST['date'] , 4, 2):(int)substr($_GET['date'] , 4, 2);
-                            $params['year'] = $_POST['date']?(int)substr($_POST['date'] , 0, 4):(int)substr($_GET['date'] , 0, 4);
-
-                        }
-
-			echo $this->printer_friendly($this->print_week_new($params),lang('Weekview'));
-			
+			echo $this->printer_friendly($this->get_week(),lang('Weekview'));
 			$GLOBALS['phpgw']->common->phpgw_footer();
 		}
@@ -727,4 +593,14 @@
 			if (isset($this->bo->prefs['calendar']['display_minicals']) && $this->bo->prefs['calendar']['display_minicals'] == "1" && !$this->bo->printer_friendly)
 			{
+				$minical_this = $this->mini_calendar(
+					Array(
+						'day'	=> $this->bo->day,
+						'month'	=> $this->bo->month,
+						'year'	=> $this->bo->year,
+						'link'	=> 'day',
+						'butons'	=> 'none',
+						'outside_month'	=> False
+					)
+				);
 				$minical_prev = $this->mini_calendar(
 					Array(
@@ -747,19 +623,9 @@
 					)
 				);
-                                $minical_this = $this->mini_calendar(
-					Array(
-						'day'	=> $this->bo->day,
-						'month'	=> $this->bo->month,
-						'year'	=> $this->bo->year,
-						'link'	=> 'day',
-						'butons'	=> 'none',
-						'outside_month'	=> False
-					)
-				);
 			}
 			else
 			{
 
-			//NDEE: printer-friendly what?
+//NDEE: printer-friendly what?
 				$minical_this = '';
 				$minical_prev = '';
@@ -773,12 +639,10 @@
 				$prev_week_link = '<a href="'.$this->page('week','&date='.$prev['full']).'">&lt;&lt;</a>';
 				$next_week_link = '<a href="'.$this->page('week','&date='.$next['full']).'">&gt;&gt;</a>';
-				$print = '<a href="javascript:void(0);" onclick="scheduler.toPDF('."'calendar/js/dhtmlx/server/generate.php'".')">['.lang('Printer Friendly').']</a>';
-				
-                                //$print = '<a href="'.$this->page('week','&friendly=1&date='.sprintf("%04d%02d%02d",$this->bo->year,$this->bo->month,$this->bo->day))."\" TARGET=\"cal_printer_friendly\" onMouseOver=\"window.status = '".lang('Generate printer-friendly version')."' \">[".lang('Printer Friendly').']</a>';
+				$print = '<a href="'.$this->page('week','&friendly=1&date='.sprintf("%04d%02d%02d",$this->bo->year,$this->bo->month,$this->bo->day))."\" TARGET=\"cal_printer_friendly\" onMouseOver=\"window.status = '".lang('Generate printer-friendly version')."'\">[".lang('Printer Friendly').']</a>';
 			}
 			else
 			{
 
-				//NDEE: printer-friendly (weekly-view)
+//NDEE: printer-friendly (weekly-view)
 				$printer = '<body bgcolor="'.$this->theme['bg_color'].'">';
 				$prev_week_link = '';
@@ -807,5 +671,5 @@
 				'print'			=>	$print
 			);
-			//todo
+//todo
 			$p = CreateObject('phpgwapi.Template',$this->template_dir);
 			$p->set_file(
@@ -968,5 +832,7 @@
 			);
 
-			$button_left = $button_center = $button_right = '';
+			$p->set_file(Array('form_button'			=> 'form_button_script.tpl'	));
+
+			$button_left = $button_center = $button_right = $button_right_suggestion = '';
 
 			if($this->bo->check_perms(PHPGW_ACL_EDIT,$event))
@@ -976,4 +842,6 @@
 					$var = Array(
 						'action_url_button'	=> $this->page('edit','&cal_id='.$cal_id),
+                                                // added date to the action parameteres so we can add an exception to an edited event 
+ 		                                'action_url_button'     => $this->page('edit','&cal_id='.$cal_id.'&date='.$date), 
 						'action_text_button'	=> lang('Edit Single'),
 						'action_confirm_button'	=> '',
@@ -1027,5 +895,5 @@
 						'action_url_button'	=> $this->page('delete','&cal_id='.$cal_id),
 						'action_text_button'	=> lang('Delete Single'),
-						'action_confirm_button'	=> "onClick=\"return confirm('".lang('Are you sure want to delete this single occurence?').'\\n'.lang('This will delete this entry for all users.')."')\"",
+						'action_confirm_button'	=> "onClick=\"return confirm('".lang('Are you sure want to delete this single occurence?\\nThis will delete this entry for all users.')."')\"",
 						'action_extra_field'	=> $this->html->input_hidden(array(
 							'delete_type' => 'single',
@@ -1092,4 +960,13 @@
 				}
 			}
+			$uid          	 = $event['uid'];
+			$owner        	 = $event['owner'];
+			$title       	 = $event['title'];
+			$description 	 = rtrim(utf8_encode($event['description'])); 
+			$location   	 = $event['location'];
+			$start			 = $event['start'];
+			$end		     = $event['end'];
+                       
+ 			$p->set_var( 'suggestion', $this->build_suggestion( $event , $GLOBALS['phpgw_info']['user']['account_id']) );
 
 			$var = Array(
@@ -1113,8 +990,13 @@
 				$button_left .= '<td>'.$p->fp('button','form_button').'</td>';
 			}
+                        
+                        $label_suggest = lang('Suggest new hour'); 
+                        $button_right_suggestion = "<td><input type=\"button\" style=\"height: 16px; width: 110px; font-size: 10px;\" value=\"" . $label_suggest . "\"onclick=\"show_suggestion()\";</td>"; 
+                        
 			$p->set_var(array(
 				'button_left'	=> $button_left,
 				'button_center'	=> $button_center,
-				'button_right'	=> $button_right
+				'button_right'	=> $button_right,
+				'button_right_suggestion' => $button_right_suggestion
 			));
 			$p->pfp('phpgw_body','view_event');
@@ -1128,4 +1010,144 @@
 		}
 
+		function build_suggestion( $event , $user = false )
+		{
+		    $p = $GLOBALS['phpgw']->template;
+
+		    $p->set_file(
+			    Array(
+				'suggestion'	=> 'suggestion.tpl'
+			    )
+		    );
+
+                   include_once($_SESSION['rootPath'].'/calendar/inc/class.ex_participants.inc.php');
+                   $exParticipants = new exParticipants();
+                   $exParticipants->setParticipantsBySerializable($event['ex_participants']);
+
+                    $cal_id              = $event['id'];
+		    $uid          	 = $event['uid'];
+		    $owner        	 = $event['owner'];
+		    $title       	 = $event['title'];
+		    $description 	 = rtrim(utf8_encode($event['description'])); 
+		    $location   	 = $event['location'];
+		    $start			 = $event['start'];
+		    $end		     = $event['end'];
+
+                    if( $owner == -2 )
+                    {
+                        $to = $event['organizer'];
+                        $mail = array();
+
+                        if( preg_match ('(<([^>]*@[^>]*)>)', $to, $mail ) )
+                            $to =  $mail[1];
+                    }
+                    else
+                    {
+                        $preferences = CreateObject('phpgwapi.preferences',$owner);
+                        $to = $preferences->email_address($owner);
+                    }
+      
+
+		    if(((int)$start['month']) < 10 && strlen($start['month']) == 1)
+			    $mes = "0" . $start['month'];
+		    else
+			    $mes = $start['month'];	
+
+		    if(((int)$start['mday']) < 10 && strlen($start['mday']) == 1)
+			    $dia = "0" . $start['mday'];
+		    else
+			    $dia = $start['mday'];		
+		    
+		    if(((int)$start['hour']) < 10 && strlen($start['hour']) == 1)
+			    $hor = "0" . $start['hour'];
+		    else
+			    $hor = $start['hour'];
+		    
+		    if(((int)$start['min']) < 10 && strlen($start['min']) == 1)
+			    $min = "0" . $start['min'];
+		    else
+			    $min = $start['min'];
+		    
+		    if(((int)$end['month']) < 10 && strlen($end['month']) == 1)
+			    $end['month'] = "0" . $end['month'];
+		    
+		    if(((int)$end['mday']) < 10 && strlen($end['mday']) == 1)
+			    $end['mday'] = "0" . $end['mday'];
+		    
+		    if(((int)$end['hour']) < 10 && strlen($end['hour']) == 1)
+			    $end['hour'] = "0" . $end['hour'];
+			    
+		    if(((int)$end['min']) < 10 && strlen($end['min']) == 1)
+			    $end['min'] = "0" . $end['min'];
+
+		    $start_date  = $dia . "/" . $mes . "/" . $start['year']; 
+		    $start_hour  = $hor . ":" . $min; 				
+		    $end_date    =  $end['mday'] . "/" . $mes . "/" . $start['year'];
+		    $end_hour    =  $end['hour'] . ":" . $end['min'];
+
+		    $notify_message = lang('suggest new hour');
+		    $start_h = substr($start_hour, 0, strpos($start_hour, ":"));
+		    $start_m = substr($start_hour, strpos($start_hour, ":")+1);
+		    $end_h   = substr($end_hour, 0, strpos($end_hour, ":"));
+		    $end_m   = substr($end_hour, strpos($end_hour, ":")+1);
+
+		    $p->set_var('notify_message', $notify_message);
+		    $p->set_var('action_form', $this->page('send_suggest_owner'));
+		    $p->set_var('lang_start_hour', lang('Start hour'));
+		    $p->set_var('lang_end_hour', lang('End hour'));
+		    $p->set_var('lang_start_date', lang('Start date'));
+		    $p->set_var('lang_end_date', lang('End date'));
+		    $p->set_var('lang_suggest_new_hour', lang('Suggest new hour'));
+		    $p->set_var('cal_id', $cal_id);
+		    $p->set_var('to', $to);
+		    $p->set_var('title', $title);
+		    $p->set_var('description', $description);
+		    $p->set_var('uid', $uid);
+		    $p->set_var('location', $location);
+		    $p->set_var('ex_participants', $exParticipants->getParticipantsMailsString());
+		    $p->set_var('start_date', $start_date);
+		    $p->set_var('start_hour', $start_h);
+		    $p->set_var('start_minute', $start_m);
+		    $p->set_var('end_date', $end_date);
+		    $p->set_var('end_hour', $end_h);
+		    $p->set_var('end_minute', $end_m);
+		    $p->set_var('url', $GLOBALS['phpgw_info']['server']['webserver_url']);
+                    $p->set_var('user', $user);
+
+		    return $p->fp( 'suggestion', 'suggestion' );
+		}
+
+		/**
+		 * @license http://www.gnu.org/copyleft/gpl.html GPL
+		 * @abstract: método que envia a sugestão para o criador do compromisso.
+		 * @author Prognus Software Livre (http://www.prognus.com.br)
+		 */
+		function send_suggest_owner()
+		{				
+			$array_data_inicio = explode('/',$_POST['data_inicio']);
+			$array_data_final  = explode('/',$_POST['data_final']);
+			$hora_inicio       = $_POST['hora_inicio'];
+			$minuto_inicio     = $_POST['minuto_inicio'];					
+			$hora_final        = $_POST['hora_final'];
+			$minuto_final      = $_POST['minuto_final'];
+			
+			$vars = $_GET['cal_id'];
+			$array_vars = explode(";", $vars);
+			$cal_id          = $array_vars[0];
+			$to              = $array_vars[1];
+			$title_          = $array_vars[2];
+			$description_    = $array_vars[3];
+			$uid             = $array_vars[4];
+			$location        = $array_vars[5];
+			$ex_participants = $array_vars[6];
+                        $user            = $array_vars[7];                      
+			$time_suggest      = array('hora_inicio' => $hora_inicio, 'hora_final' => $hora_final, 'minuto_inicio' => $minuto_inicio, 'minuto_final' => $minuto_final);
+
+			$cal_id = $this->bo->send_suggestion_external_owner($cal_id, $uid, $to, $time_suggest, $array_data_inicio, $array_data_final, $title_, $description_, $location, $ex_participants,$user);
+
+                        Header('Location: '.$this->page('view','&cal_id='.$cal_id));
+
+                }
+	
+		
 		function edit($params='')
 		{
@@ -1186,5 +1208,6 @@
 						'event' => $event,
 						'cd'	=> $cd,
-						'plain' => $plain
+						'plain' => $plain,
+                                                'date'  =>  $_GET['date'] 
 					)
 				);
@@ -1219,4 +1242,6 @@
 		function export($vcal_id=0)
 		{
+			$extern = true;
+			$method = 'PUBLISH';
 			$temp_path = $GLOBALS['phpgw_info']['server']['temp_dir'] . SEP;
 			srand((double)microtime()*1000000);
@@ -1227,7 +1252,8 @@
 			$cal_id = get_var('cal_id',array('GET','POST'),$vcal_id);
 			$event[0] = $this->bo->read_entry($cal_id);
+			
 			include_once('class.bocalendar.inc.php');
 			$cal = new bocalendar;
-			$tmpattach=$cal->create_vcard($event);
+			$tmpattach=$cal->create_vcard($event, $method, $extern);
 			fwrite($attach_fd,$tmpattach);
 			header ("Content-Type: text/plain"); 
@@ -1422,9 +1448,9 @@
 				}
 				// Add participants
-				//$participants = explode(";", $GLOBALS['phpgw']->session->appsession("participants") );
-				//for($_f_part=0; $_f_part<count($participants); $_f_part++)
-				//{
-				//	$this->bo->add_attribute('participants','A',$participants[$_f_part]);
-				//}
+				$participants = explode(";", $GLOBALS['phpgw']->session->appsession("participants") );
+				for($_f_part=0; $_f_part<count($participants); $_f_part++)
+				{
+					$this->bo->add_attribute('participants','A',$participants[$_f_part]);
+				}
 				// Add misc
 				$this->bo->add_attribute('participants','A',$this->bo->owner);
@@ -1487,4 +1513,30 @@
 		}
 
+		
+		
+		function getLdap()
+		{
+			include_once('../phpgwapi/inc/class.common.inc.php');
+			$GLOBALS['phpgw_info']['server'] = $_SESSION['phpgw_info']['expresso']['server'];
+			$common = new common();
+	
+			if ( (!empty($GLOBALS['phpgw_info']['server']['ldap_master_host'])) &&
+				(!empty($GLOBALS['phpgw_info']['server']['ldap_master_root_dn'])) &&
+				(!empty($GLOBALS['phpgw_info']['server']['ldap_master_root_pw'])) )
+				{
+					$ldap = $common->ldapConnect($GLOBALS['phpgw_info']['server']['ldap_master_host'],
+												$GLOBALS['phpgw_info']['server']['ldap_master_root_dn'],
+												$GLOBALS['phpgw_info']['server']['ldap_master_root_pw']);
+				}
+				else
+				{
+					$ldap = $common->ldapConnect();
+				}
+
+			return $ldap;
+		}	
+		
+		
+		
 		function disponibility($params) {
 
@@ -1505,18 +1557,49 @@
 			$str_participants = substr($_GET['participants'],0,strlen($_GET['participants'])-1); //remove the last comma
 			$participants= array();
-
 			$participants_splited = explode(",",$str_participants);
-			foreach($participants_splited as $participant) {
+			
+					
+			$ldap = $this->getLdap();
+			foreach ($participants_splited as $participant)
+            {
 				$participant = substr($participant,0,strlen($participant)-1);
+
+                $entry = array();
+				$extern_contact = false;
+				
+				$justthese = array('accountStatus');
+                $filter="(&(|(phpgwAccountType=u)(phpgwAccountType=l))(uidNumber=".(int)$participant."))";
+                $search = ldap_search($ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
+                $entry = ldap_get_entries($ldap, $search);
+	
+				if($entry[0]['accountstatus'][0] == "false")
+					$extern_contact = true;
+			
+				
 				$acct_type = $GLOBALS['phpgw']->accounts->get_type((int)$participant);
+			
 				if($acct_type=='g') {
 					$bo_groups = CreateObject('expressoAdmin1_2.group');
-					$users = $bo_groups->get_info($participant,true);
+					$users = $bo_groups->get_info($participant);
 					foreach($users['memberuid_info'] as $user) {
-						if($user['type']==u)
+						if($user['type']==u){
+							if (!$user['uidnumber']){
+								continue;
+							}
 							$participants[$user['uidnumber']] = 'U';
 					}
 				}
-				else {
+				}
+				else 
+				{
+					if($extern_contact)
+					{
+						$participants[$participant] = 'I';
+						continue;
+					}
+					
+					if (!$participant)
+						continue;
+						
 					$participants[$participant] = 'U';
 				}
@@ -1665,4 +1748,6 @@
 			";
 
+			$extra_ = "";
+			
 			$str.= "<table border=\'1\' bgcolor=\"#FFFFFF\" width=\"100%\" height=\"100%\"><tr><td>";
 
@@ -1679,5 +1764,11 @@
 			foreach($participants as $part => $nul)
 			{
+				$extra_ = "";
+				
+				if($nul == 'I')
+					$extra_ = "(externalI)";
+				
 				$participants[$part] = $GLOBALS['phpgw']->common->grab_owner_name($part);
+				$participants[$part].= $extra_;
 				// Much better for processor  :)
 				$participants_id[]  .= $part;
@@ -1691,12 +1782,5 @@
 				$GLOBALS['phpgw']->preferences->save_repository();
 			}
-			if($this->bo->prefs['calendar']['interval'] == '42')
-			{
-			    $increment = 30;
-			}
-			elseif($this->bo->prefs['calendar']['interval'] == '84')
-			{
-			    $increment = 15;
-			}
+			$increment = $this->bo->prefs['calendar']['interval'];
 			$interval = (int)(60 / $increment);
 
@@ -1727,4 +1811,12 @@
 			foreach($participants as $part => $fullname)
 			{
+				$external = false;
+				if(strpos($fullname,"(externalI)")) 
+				{
+					$tmp_name = str_replace("(externalI)","",$fullname);
+					$fullname = $tmp_name;
+					$external = true;
+				}
+				
 				$str .= '<tr align="center">'
 					. '<td width="15%" align="left"><font color="'.$this->theme['bg_text'].'" face="'.$this->theme['font'].'" size="-2">'.$fullname.'</font></td>';
